﻿using NormalVersion.Properties;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls;
using Telerik.WinControls.RadControlSpy;
using Telerik.WinControls.UI;

namespace NormalVersion
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            // new RadControlSpyForm().Show();

            for (int i = 0; i < 1; i++)
            {
                RadTreeNode node = new RadTreeNode();
                node.Text = "parent node " + i;
                radTreeView1.Nodes.Add(node);

                for (int j = 0; j < 5; j++)
                {
                    node.Nodes.Add("child node " + j);
                }
            }
            radTreeView1.Nodes[0].Expand();
            radTreeView1.CheckBoxes = true;

            radTreeView1.NodeCheckedChanged += radTreeView1_NodeCheckedChanged;
        }

        void radTreeView1_NodeCheckedChanged(object sender, RadTreeViewEventArgs e)
        {
            if (e.Node.Text == "child node 0" && e.Node.Parent != null && e.Node.Parent.Text == "parent node 0")
            {
                foreach (RadTreeNode childNode in e.Node.Parent.Nodes)
                {
                    if (childNode != e.Node)
                    {
                        childNode.ShowCheckBox = !e.Node.Checked;
                        childNode.Image = e.Node.Checked ? Resources._unchecked : null;
                    }
                }
                return;
            }

            if (e.Node.Parent != null)
            {
                bool flag = false;
                foreach (RadTreeNode node in e.Node.Parent.Nodes)
                {
                    if (node.Text == "child node 0")
                    {
                        continue;
                    }

                    if (node.Checked == false)
                    {
                        flag = true;
                        break;
                    }
                }

                foreach (RadTreeNode node in e.Node.Parent.Nodes)
                {
                    if (node.Text == "child node 0")
                    {
                        node.ShowCheckBox=  flag;
                        node.Image = flag ? null : Resources._unchecked;
                    }
                }
            }
        }
    }
}